//---------------------------------------------------------------------------
#include <iostream>
#include <fstream>
#include <vector>
#include <vcl.h>
#pragma hdrstop
#include "setup.h"
#include "message.h"
#include "restore.h"
#include <math.h>

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMain *frmMain;
TStringList *fileNames = new TStringList;
TStringList *friendlyNames = new TStringList;
Graphics::TBitmap *backBuffer = new Graphics::TBitmap;
Graphics::TBitmap *backBufferPreview = new Graphics::TBitmap;
bool english = true;
AnsiString path = "";
AnsiString filename = "";
int currentFrame = 0;
TPoint drawoffset;
TPoint wentDownAt;
bool mouseIsDown = false;
bool rightClick = false;
int wentDownIn = -1;
bool isSpacePressed = false;
TPoint logicalPosition;
struct threeval
{
 float a,b,c;
 float d,e,f; //custom multiple-move shit
};
std::vector<std::vector<threeval> > animData(1);
std::vector<int> constraints(0);
std::vector<int> gostekconstraints(0);
std::vector<Graphics::TBitmap*> images(20);

struct TFPoint {float x, y;};

const PO_COUNT = 6;

const AnsiString bodyParts[20] = {"Left foot","Right foot","Right leg lower","Left leg lower","Left leg upper",
                                  "Right leg upper","Right torso","Left torso","Neck-bottom","Left shoulder",
                                  "Right shoulder","Head","Left arm","Right arm","Right hand",
                                  "Left hand","Left ground point","Right ground point","Right special","Left special"};
const AnsiString imageNames[20] = {"stopa","stopa","noga","noga","udo", "udo",
                                  "Right torso","Left torso","Neck-bottom","Left shoulder",
                                  "Right shoulder","Head","Left arm","Right arm","Right hand",
                                  "Left hand","Left ground point","Right ground point","Right special","Left special"};
const int gostekDraw[20] = {16, 17, 1, 0, 3, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

/*
 facing right:
*/

void loadImages()
{
        for (int i = 0; i < 6; i++)
        {
                images[i] = new Graphics::TBitmap;
                images[i]->LoadFromFile(path + "\\gostek-gfx\\" + imageNames[i] + ".bmp");
        }
}  

void loadFile(AnsiString name, bool intoGostek)
{
 animData.resize(1);
 animData[0].resize(0);
 if (intoGostek)
        gostekconstraints.resize(0);
 else
        constraints.resize(0);
 char buffer[256];
 bool constraintload = false;
 std::ifstream file;
 AnsiString s;
 int currentXYZ = 1;
 file.open(name.c_str(), ios::in);
 if (file.good())
 {
        //check for .po or .poa and update save dialog
        if (name[name.Length()] == 'a') //if .poa
        {
                frmMain->svdSave->DefaultExt = "poa";
                frmMain->lblItems->Caption = "Body parts";
                frmMain->btnSave->Enabled = true;
                frmMain->btnSaveAs->Enabled = true;
        }
        else
        {
                frmMain->svdSave->DefaultExt = "po";
                frmMain->lblItems->Caption = "Points";
                frmMain->btnSave->Enabled = false;
                frmMain->btnSaveAs->Enabled = false;
        }
        frmMain->btnPlay->Visible = (name[name.Length()] == 'a');
        frmMain->trcFrame->Visible = (name[name.Length()] == 'a');
        frmMain->edtFrame->Visible = (name[name.Length()] == 'a');
        frmMain->lblOutof->Visible = (name[name.Length()] == 'a');
        frmMain->btnAdd->Visible = (name[name.Length()] == 'a');
        frmMain->btnSub->Visible = (name[name.Length()] == 'a');
        if (!intoGostek)
        {
                filename = name;
                frmMain->Caption = "POA editor - " + name.LowerCase();
        }
        drawoffset = Point(0,0);
        TStringList *theFile = new TStringList;
        while (!file.eof())
        {
                file.getline(buffer, 256);
                s = ((AnsiString)buffer).Trim();
                if ((s != "ENDFILE") && (s != ""))
                {
                        int i = s.Pos(' ');
                        while (i != 0)
                        {
                                theFile->Add(s.SubString(1, i-1));
                                s = (s.SubString(i+1, s.Length())).Trim();
                                i = s.Pos(' ');
                        }
                        theFile->Add(s);
                }
        }
        file.close();   
        for (int i = 0; i < theFile->Count; i++)
        {
        s = theFile->Strings[i];
        if (s == "NEXTFRAME")
        {
                currentXYZ = 1;
                animData.resize(animData.size()+1);
        }
        else
        if (s == "CONSTRAINTS")
                constraintload = true;
        else
        {
                if ((!constraintload) && (!intoGostek))
                {
                        switch (currentXYZ)
                        {
                                case 1: animData[animData.size()-1].resize(animData[animData.size()-1].size()+1);
                                        currentXYZ = 2;
                                        break;
                                case 2: animData[animData.size()-1][animData[animData.size()-1].size()-1].a = StrToFloat(s);
                                        currentXYZ = 3;
                                        break;
                                case 3: animData[animData.size()-1][animData[animData.size()-1].size()-1].b = StrToFloat(s);
                                        currentXYZ = 4;
                                        break;
                                case 4: animData[animData.size()-1][animData[animData.size()-1].size()-1].c = StrToFloat(s);
                                        currentXYZ = 1;
                                        break;
                        }
                }
                else
                        if (constraintload)
                        {
                                s = s.SubString(2, s.Length()-1);
                                if (!intoGostek)
                                        constraints.push_back(StrToInt(s));
                                else
                                        gostekconstraints.push_back(StrToInt(s));
                        }
                }
        }
        frmMain->lstItems->Items->Clear();
        if (animData[0].size() == 20)
                for (unsigned i = 0; i < 20; i++)
                        frmMain->lstItems->Items->Add(bodyParts[i]);
        else
                for (unsigned i = 0; i < animData[0].size(); i++)
                        frmMain->lstItems->Items->Add(IntToStr(i));
        frmMain->trcFrame->Max = animData.size()-1;
        frmMain->trcFrame->Position = 0;
        frmMain->edtFrame->Text = "1";
        frmMain->trcFrameChange(NULL);
        frmMain->lblOutof->Caption = "/" + IntToStr(animData.size());
        frmMain->updateImage();
 }
 else
        ShowMessage("Could not open file!");
}

void createBackup()
// creates a binary backup file (backup.poc) of all the animations
{
 //show a message...is this necessary?
 frmMessage->Show();
 frmMessage->Label1->Caption = "Please wait, creating backup file";
 frmMessage->Update();

 //open the file
 std::ofstream fileout;
 fileout.open("backup.poc", ios::out | ios::binary);

 //for each file, write out a blank int that will later hold reference within file
 int z = 0;
 for (int i = PO_COUNT; i < fileNames->Count; i++)
  fileout.write((char*)&z, sizeof(int));

 //for each animation file
 for (int i = PO_COUNT; i < fileNames->Count; i++)
 {
        //get the current file location, and write it to the start of file
        z = fileout.tellp();
        fileout.seekp((i-PO_COUNT)*sizeof(int));
        fileout.write((char*)&z, sizeof(int));
        fileout.seekp(z);

        //load the file in question
        if (i < PO_COUNT) //in case editing objects is enabled again
                loadFile(path + "objects\\" + fileNames->Strings[i], false);
        else
                loadFile(path + "anims\\" + fileNames->Strings[i], false);

        unsigned bob;
        //write out frames
        bob = animData.size();
        fileout.write((char*)&bob, sizeof(unsigned));

        //write out vertice count
        bob = animData[0].size();
        fileout.write((char*)&bob, sizeof(unsigned));

        //write out constraint count
        bob = constraints.size();
        fileout.write((char*)&bob, sizeof(unsigned));

        //write out points
        for (unsigned ill = 0; ill < animData.size(); ill++)
        {
                for (unsigned j = 0; j < animData[ill].size(); j++)
                {
                        fileout.write((char*)&animData[ill][j].a, sizeof(float));
                        fileout.write((char*)&animData[ill][j].b, sizeof(float));
                        fileout.write((char*)&animData[ill][j].c, sizeof(float));
                }
        }

        //write out constraints
        for (unsigned ill = 0; ill < constraints.size(); ill++)
                fileout.write((char*)&constraints[ill], sizeof(constraints[ill]));
 }
 //clean up
 fileout.close();
 frmMessage->Hide();
}

void loadFileNames()
{
 fileNames->Clear();
 char buffer[256];
 AnsiString s;  
 std::ifstream file("data\\files.txt", ios::in);
 if (file.good())
 {
        while (!file.eof())
        {
                file.getline(buffer, 256);
                s = (AnsiString)buffer;
                fileNames->Add(s);
        }
 }
 file.close();
}

void loadFriendlyNames()
{
 friendlyNames->Clear();
 TMenuItem *menuItem;
 char buffer[256];
 AnsiString s;
 std::ifstream file;
 if (english)
        file.open("data\\english.txt", ios::in);
 else
        file.open("data\\polish.txt", ios::in);
 if (file.good())
 {
        while (!file.eof())
        {
                file.getline(buffer, 256);
                s = (AnsiString)buffer;
                menuItem = new TMenuItem(frmMain);
                menuItem->Caption = s;
                friendlyNames->Add(s);
                menuItem->OnClick = frmMain->predefdClick;
                if (frmMain->popItems->Items->Count > 6)
                        menuItem->Tag = frmMain->popItems->Items->Count - 1;
                else
                        menuItem->Tag = frmMain->popItems->Items->Count;
                if (frmMain->popItems->Items->Count % 24 == 0)
                        menuItem->Break = mbBarBreak;
                frmMain->popItems->Items->Add(menuItem);
                if (frmMain->popItems->Items->Count == 6)
                {
                        menuItem = new TMenuItem(frmMain);
                        menuItem->Caption = "-";
                        frmMain->popItems->Items->Add(menuItem);
                }

        }
  }
  file.close();
  menuItem = new TMenuItem(frmMain);
  menuItem->Caption = "-";
  frmMain->popItems->Items->Add(menuItem);
  menuItem = new TMenuItem(frmMain);
  menuItem->Caption = "Other...";
  menuItem->OnClick = frmMain->bydialogClick;
  frmMain->popItems->Items->Add(menuItem);
}

void initEditor()
{
 frmMain->popItems->Items->Clear();
 char buffer[256];
 std::ifstream file ("options.ini", ios::in);
 file.getline(buffer, 256);
 path = ((AnsiString)buffer).Trim();
 if (path[path.Length()] != '\\')
  path = path + "\\";
 frmMain->opnOpen->InitialDir = path;
 frmMain->svdSave->InitialDir = path;
 file.getline(buffer, 256);
 english = ((((AnsiString)buffer).UpperCase()).Trim() == "ENGLISH");
 file.close();

 loadFileNames();
 loadFriendlyNames();

 if (!FileExists("backup.poc")) //if no backup
        createBackup(); //create it

 loadImages();
 loadFile(path + "objects\\gostek.po", true);
 for (int i = PO_COUNT; i < fileNames->Count; i++)
        frmRestore->chkFiles->Items->Add(friendlyNames->Strings[i] + " (" + fileNames->Strings[i] + ")");
}


TPoint pointAt(int point)
{
 TPoint result = Point((animData[currentFrame][point].a*25)+120, (animData[currentFrame][point].c*25)+40);
 result.x = frmMain->imgMain->Width - result.x + drawoffset.x;
 result.y = frmMain->imgMain->Height - result.y - drawoffset.y;
 return result;
}

TFPoint reversePointAt(TPoint point)
{
 TPoint result;
 result.x = frmMain->imgMain->Width - point.x + drawoffset.x;
 result.y = frmMain->imgMain->Height - point.y - drawoffset.y;
 TFPoint resl = {(result.x - 120) / 25.0f, (result.y - 40) / 25.0f};
 return resl;
}

TPoint pointAtXY(float x, float y)
{
 TPoint result = Point((x*25)+120, (y*25)+40);
 result.x = frmMain->imgMain->Width - result.x + drawoffset.x;
 result.y = frmMain->imgMain->Height - result.y - drawoffset.y;
 return result;
}

void __fastcall TfrmMain::updateImage()
{
 TPoint xy;
 //int sizeDif = (imgMain->Width - 40) / imgPreview->Width;
 backBuffer->Canvas->Brush->Color = clWhite;
 backBuffer->Canvas->Pen->Color = clBlack;
 backBuffer->Canvas->Rectangle(0,0,imgMain->Width, imgMain->Height);

 backBufferPreview->Canvas->Brush->Color = clWhite;
 backBufferPreview->Canvas->Pen->Color = clBlack;
 backBufferPreview->Canvas->Rectangle(0,0,backBufferPreview->Width, backBufferPreview->Height);

 TPoint *plgPoints = new TPoint[3];
 if (constraints.size() != 0)
  for (unsigned i = 0; i < constraints.size(); i = i+2)
  {
   backBuffer->Canvas->MoveTo(pointAt(constraints[i]-1).x, pointAt(constraints[i]-1).y);
   backBuffer->Canvas->LineTo(pointAt(constraints[i+1]-1).x, pointAt(constraints[i+1]-1).y);
  }
 else
  for (unsigned i = 0; i < gostekconstraints.size(); i = i+2)
  if ((gostekconstraints[i]-1 <= (signed)animData[currentFrame].size()) && (gostekconstraints[i+1]-1 <= (signed)animData[currentFrame].size()))
  {
   backBuffer->Canvas->MoveTo(pointAt(gostekconstraints[i]-1).x, pointAt(gostekconstraints[i]-1).y);
   backBuffer->Canvas->LineTo(pointAt(gostekconstraints[i+1]-1).x, pointAt(gostekconstraints[i+1]-1).y);
  }
 for (unsigned i = 0; i < animData[currentFrame].size(); i++)
 {
  if (i < 16)
   backBuffer->Canvas->Brush->Color = clRed;
  else
   backBuffer->Canvas->Brush->Color = clGreen;
  if (lstItems->Selected[i])
        backBuffer->Canvas->Brush->Color = clYellow;
  xy = pointAt(i);
  backBuffer->Canvas->Rectangle(xy.x-3, xy.y-3, xy.x+3, xy.y+3);
  /*if (i < 6)
  {
    TPoint nextPoint = pointAt(gostekDraw[i]);
    nextPoint.x = nextPoint.x / sizeDif;
    nextPoint.y = nextPoint.y / sizeDif;
    TPoint nxy = TPoint(xy.x / sizeDif, xy.y / sizeDif);
    float angle = atan2(nextPoint.y - nxy.y, nextPoint.x - nxy.x);
    TPoint change = Point(sin(angle) * images[i]->Height, cos(angle) * images[i]->Height);
    plgPoints[0] = Point(nxy.x, nxy.y);
    plgPoints[1] = Point(nextPoint.x, nextPoint.y);
    plgPoints[2] = Point(nxy.x + change.x, nxy.y - change.y);
    PlgBlt(backBufferPreview->Canvas->Handle, plgPoints, images[i]->Canvas->Handle, 0, 0, images[i]->Width, images[i]->Height,
    NULL, 0, 0);
  }    */
  imgPreview->Refresh();  
 }
 //draw 0,0 point
 backBuffer->Canvas->Pen->Color = clBlue;
 TPoint at00 = pointAtXY(0,0);
 backBuffer->Canvas->MoveTo(0, at00.y);
 backBuffer->Canvas->LineTo(backBuffer->Width, at00.y);
 backBuffer->Canvas->MoveTo(at00.x, at00.y - 3);
 backBuffer->Canvas->LineTo(at00.x, at00.y + 4);
 if (rightClick) //draw pivot point
 {
        backBuffer->Canvas->Pen->Color = clFuchsia;
        backBuffer->Canvas->MoveTo(wentDownAt.x, wentDownAt.y - 5);
        backBuffer->Canvas->LineTo(wentDownAt.x, wentDownAt.y + 5);
        backBuffer->Canvas->MoveTo(wentDownAt.x - 5, wentDownAt.y);
        backBuffer->Canvas->LineTo(wentDownAt.x + 5, wentDownAt.y);
 }
 imgMain->Canvas->CopyRect(Rect(0,0,imgMain->Width, imgMain->Height), backBuffer->Canvas, Rect(0,0,imgMain->Width, imgMain->Height));
 //imgPreview->Canvas->CopyRect(Rect(0,0,imgPreview->Width, imgPreview->Height), backBufferPreview->Canvas, Rect(0,0,imgPreview->Width, imgPreview->Height));
 imgMain->Refresh();
 delete plgPoints;
}

void __fastcall TfrmMain::lstItemsClick(TObject *Sender)
{
 updateImage();
 if (lstItems->SelCount != 0)
 {
  for (int i = 0; i < lstItems->Items->Count; i++)
   if (lstItems->Selected[i])
    {
     imgMain->Canvas->Brush->Color = clYellow; 
     TPoint xy = pointAt(i);
     imgMain->Canvas->Rectangle(xy.x-3, xy.y-3, xy.x+3, xy.y+3);
     if (Sender != imgMain)
     {
      animData[currentFrame][i].d = animData[currentFrame][i].a;
      animData[currentFrame][i].e = animData[currentFrame][i].b;
      animData[currentFrame][i].f = animData[currentFrame][i].c;
     } 
    }
 }
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::btnPlayClick(TObject *Sender)
{
 tmrPlay->Enabled = !tmrPlay->Enabled;
 trcFrame->Position = currentFrame;
 trcFrameChange(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::tmrPlayTimer(TObject *Sender)
{
 if ((unsigned)currentFrame == animData.size() - 1)
  currentFrame = 0;
 else
  currentFrame++;
 trcFrame->Position = currentFrame;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::predefdClick(TObject *Sender)
{
  if (((TComponent*)Sender)->Tag < 6)
   loadFile(path + "objects\\" + fileNames->Strings[((TComponent*)Sender)->Tag], false);
  else
   loadFile(path + "anims\\" + fileNames->Strings[((TComponent*)Sender)->Tag], false);
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::bydialogClick(TObject *Sender)
{
 if (opnOpen->Execute())
 {
        loadFile(opnOpen->FileName, false);
 }
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::FormCreate(TObject *Sender)
{
 backBuffer->Width = imgMain->Width;
 backBuffer->Height = imgMain->Height;
 backBufferPreview->Width = imgPreview->Width;
 backBufferPreview->Height = imgPreview->Height;
 btnPlay->NumGlyphs = 4;
 DecimalSeparator = '.';
}
//---------------------------------------------------------------------------



void __fastcall TfrmMain::trcFrameChange(TObject *Sender)
{
 currentFrame = trcFrame->Position;
 edtFrame->Text = IntToStr(currentFrame + 1);
 updateImage();
}
//---------------------------------------------------------------------------   

void __fastcall TfrmMain::imgMainMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{        
 wentDownIn = -1;
 wentDownAt = Point(X, Y);
 GetCursorPos(&logicalPosition);
 rightClick = Button == mbRight;
 if ((!isSpacePressed) && (!rightClick))
 {
        for (unsigned i = 0; i < animData[currentFrame].size(); i++)
        {
                TPoint xy = pointAt(i);
                if (PtInRect(Rect(xy.x - 3, xy.y - 3, xy.x + 3, xy.y + 3), Point(X, Y)))
                        wentDownIn = i;
        }
        bool inASelected = false;
        for (int i = 0; i < lstItems->Count; i++)
        {
                TPoint xy = pointAt(i);
                if ((lstItems->Selected[i]) && (PtInRect(Rect(xy.x - 3, xy.y - 3, xy.x + 3, xy.y + 3), Point(X, Y))))
                        inASelected = true;
        }
        if ((!inASelected) || (Shift.Contains(ssCtrl)))
        {
                if ((!Shift.Contains(ssCtrl)))
                {
                        lstItems->ItemIndex = -1;
                        for (int i = 0; i < lstItems->Items->Count; i++)
                        lstItems->Selected[i] = false;
                }
                for (unsigned i = 0; i < animData[currentFrame].size(); i++)
                {
                        TPoint xy = pointAt(i);
                        if ((PtInRect(Rect(xy.x - 3, xy.y - 3, xy.x + 3, xy.y + 3), Point(X, Y))))
                        {
                                lstItems->Selected[i] = !lstItems->Selected[i];
                        }
                }
        }
        lstItemsClick(NULL);
 }
 if (rightClick)
        imgMain->Cursor = crNone;
 mouseIsDown = true; 
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::FormShow(TObject *Sender)
{
 initEditor(); //initialise everything

 imgMain->Canvas->Rectangle(0,0,imgMain->Width, imgMain->Height); //and clear the canvas
}
//---------------------------------------------------------------------------  

void __fastcall TfrmMain::btnLoadMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
 //popup the files menu
 popItems->Popup(frmMain->Left + btnLoad->Left + X, frmMain->Top + btnLoad->Top + Y + 10);
}
//---------------------------------------------------------------------------

void saveFile(AnsiString name)
{
 std::ofstream file;
 file.open(name.c_str(), ios::out);
 bool ispo = true;
 AnsiString poadd = "P";
 if (name[name.Length()] == 'a')
 {
  ispo = false;
  poadd = "";
 }
 if (file.good())
 {
  for (unsigned i = 0; i < animData.size(); i++)
  {
   //write out points
   for (unsigned j = 0; j < animData[i].size(); j++)
   {
    file << poadd << IntToStr(j+1) << '\n';
    file << FloatToStr(animData[i][j].a) << '\n';
    file << FloatToStr(animData[i][j].b) << '\n';
    file << FloatToStr(animData[i][j].c) << '\n';
   }
   if (i != animData.size()-1)
    file << "NEXTFRAME" << '\n';
  }
  if (ispo)
  {
   file << "CONSTRAINTS" << '\n';
   for (unsigned i = 0; i < constraints.size(); i++)
    file << poadd << constraints[i] << '\n';//write out constraints
  }
  file << "ENDFILE";
  file.close();
 }
}

void __fastcall TfrmMain::btnSaveClick(TObject *Sender)
{
 if (Application->MessageBox("Are you sure you want to overwrite the orignal file?", "Overwrite?", MB_YESNO) == IDYES)
  saveFile(filename);
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnSaveAsClick(TObject *Sender)
{
 if (svdSave->Execute())
 {
  saveFile(svdSave->FileName);
  filename = svdSave->FileName;
  frmMain->Caption = "POA editor - " + filename.LowerCase();
 }
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::imgMainMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{ 
  mouseIsDown = false;
  for (int i = 0; i < lstItems->Items->Count; i++)
                if (lstItems->Selected[i])
                {
                        animData[currentFrame][i].d = animData[currentFrame][i].a;
                        animData[currentFrame][i].f = animData[currentFrame][i].c;
                }
  imgMain->Cursor = crDefault;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::imgMainMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
 if ((isSpacePressed) && (mouseIsDown))
 {
        drawoffset.x += ((X - wentDownAt.x));
        drawoffset.y -= ((Y - wentDownAt.y));
        wentDownAt = Point(X, Y);
        updateImage();
 }                      
 else
 if ((mouseIsDown) && (lstItems->SelCount != 0))
 {
  TPoint difference = Point(wentDownAt.x - X, wentDownAt.y - Y);
  if (!rightClick)
  {     //move it!
        for (int i = 0; i < lstItems->Items->Count; i++)
                if (lstItems->Selected[i])
                {
                        animData[currentFrame][i].a = animData[currentFrame][i].d;
                        animData[currentFrame][i].c = animData[currentFrame][i].f;
                        TPoint origPoint = pointAt(i);
                        origPoint.x -= difference.x;
                        origPoint.y -= difference.y;
                        animData[currentFrame][i].a = ((float)(frmMain->imgMain->Width + drawoffset.x - origPoint.x - 120)) / 25.0;
                        animData[currentFrame][i].c = ((float)(frmMain->imgMain->Height - drawoffset.y - origPoint.y - 40)) / 25.0;
                }
  }
  else
  {     //rotate it!
        TFPoint fixedWentDown = reversePointAt(wentDownAt);
        float radianAngle = (M_PI* (X - wentDownAt.x)) / 180;
        for (int i = 0; i < lstItems->Items->Count; i++)
                if (lstItems->Selected[i])
                {
                        TFPoint origPoint = {animData[currentFrame][i].a, animData[currentFrame][i].c};
                        /*animData[currentFrame][i].a = ((float)(frmMain->imgMain->Width + drawoffset.x - origPoint.x - 120)) / 25.0;
                        animData[currentFrame][i].c = ((float)(frmMain->imgMain->Height - drawoffset.y - origPoint.y - 40)) / 25.0;*/
                        TFPoint pivotDifference = {origPoint.x - fixedWentDown.x, origPoint.y - fixedWentDown.y};
                        TFPoint result;

                        result.x=cos(radianAngle)*pivotDifference.x-sin(radianAngle)*pivotDifference.y;
                        result.y=sin(radianAngle)*pivotDifference.x+cos(radianAngle)*pivotDifference.y;

                        animData[currentFrame][i].a = result.x + fixedWentDown.x;
                        animData[currentFrame][i].c = result.y + fixedWentDown.y;
                }
        SetCursorPos(logicalPosition.x, logicalPosition.y);
        //wentDownAt = Point(X, Y);
  }
  lstItemsClick(imgMain);
 }
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::btnAddMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
 popAddFrame->Popup(frmMain->Left + btnAdd->Left + X, frmMain->Top + btnAdd->Top + Y + 10);
 //update trackbar in menu click          
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnSubClick(TObject *Sender)
{
 if (animData.size() == 1)
        ShowMessage("Cannot delete the only frame in an animation");
 else
 if (Application->MessageBox("Delete current frame?", "Delete?", MB_OKCANCEL) == IDOK)
 {
  for (unsigned i = currentFrame; i < animData.size()-1; i++)
  //copy across
   for (unsigned j = 0; j < animData[i].size(); j++)
    animData[i][j] = animData[i+1][j];
  animData.resize(animData.size()-1);
  //update trackbar.
  if (trcFrame->Position == (signed)animData.size())
   trcFrame->Position--;
  trcFrame->Max--;
  lblOutof->Caption = "/" + IntToStr(animData.size());
  trcFrameChange(NULL);
 }
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::mniAddToEndClick(TObject *Sender)
{
 animData.resize(animData.size()+1);
 animData[animData.size()-1].resize(animData[animData.size()-2].size());
 for (unsigned j = 0; j < animData[animData.size()-2].size(); j++)
  animData[animData.size()-1][j] = animData[animData.size()-2][j];
 trcFrame->Max++;
 lblOutof->Caption = "/" + IntToStr(animData.size());
 trcFrame->Position = animData.size()-1;
 trcFrameChange(NULL);
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::edtFrameKeyPress(TObject *Sender, char &Key)
{
 trcFrameChange(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::edtFrameChange(TObject *Sender)
{
 if (edtFrame->Text != "")
  trcFrame->Position = StrToInt(edtFrame->Text)-1;        
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::mniInsertClick(TObject *Sender)
{
 animData.resize(animData.size()+1);
 animData[animData.size()-1].resize(animData[animData.size()-2].size());
 for (unsigned i = animData.size()-1; i > (unsigned)currentFrame; i--)
  for (unsigned j = 0; j < animData[animData.size()-2].size(); j++)
   animData[i][j] = animData[i-1][j];
 trcFrame->Max++;
 trcFrame->Position++;
 lblOutof->Caption = "/" + IntToStr(animData.size());
 trcFrameChange(NULL);
}
//---------------------------------------------------------------------------
void restoreFile()
{
 std::vector<std::vector<threeval> > animData2(animData.size());
 std::vector<int> constraints2(constraints.size());
 for (unsigned i = 0; i < animData.size(); i++)
 {
  animData2[i].resize(animData[i].size());
  for (unsigned j = 0; j < animData[i].size(); j++)
   animData2[i][j] = animData[i][j];
 }
 for (unsigned i = 0; i < constraints.size(); i++)
  constraints2[i] = constraints[i];
 std::ifstream file;
 file.open("backup.poc", ios::in | ios::binary);
 for (int i = 0; i < frmRestore->chkFiles->Items->Count; i++)
  if ((frmRestore->chkFiles->Checked[i])) //elected to restore it
 { //restore this file
  frmMessage->Show();
  frmMessage->Label1->Caption = "Please wait, restoring file 1 / " + IntToStr(frmRestore->chkFiles->Items->Count);
  frmMessage->Update();
  int bobo;
  unsigned bob;
  file.seekg(i*sizeof(int));
  file.read((char*)&bobo, sizeof(int));
  file.seekg(bobo);
  file.read((char*)&bob, sizeof(unsigned));
  animData.resize(bob);
  file.read((char*)&bob, sizeof(unsigned));
  for (unsigned j = 0; j < animData.size(); j++)
   animData[j].resize(bob);
  file.read((char*)&bob, sizeof(unsigned));
  constraints.resize(bob);
  for (unsigned j = 0; j < animData.size(); j++)
   for (unsigned g = 0; g < animData[j].size(); g++)
   {
    file.read((char*)&animData[j][g].a, sizeof(float));
    file.read((char*)&animData[j][g].b, sizeof(float));
    file.read((char*)&animData[j][g].c, sizeof(float));
   }
 for (unsigned j = 0; j < constraints.size(); j++)
  file.read((char*)&constraints[j], sizeof(constraints[j]));
  /*if (i < PO_COUNT)
   saveFile(path + "objects\\" + fileNames->Strings[i]);
  else                        */
   saveFile(path + "anims\\" + fileNames->Strings[i+PO_COUNT]);
 }
 file.close();
 //restore old value
 animData.resize(animData2.size());
 constraints.resize(constraints2.size());
 for (unsigned i = 0; i < animData2.size(); i++)
 {
  animData[i].resize(animData2[i].size());
  for (unsigned j = 0; j < animData2[i].size(); j++)
   animData[i][j] = animData2[i][j];
 }
 for (unsigned i = 0; i < constraints2.size(); i++)
  constraints[i] = constraints2[i];
 frmMessage->Hide();
}

//---------------------------------------------------------------------------


void __fastcall TfrmMain::btnRestoreClick(TObject *Sender)
{
 //show the 'restore' form
 if (frmRestore->ShowModal() == 1)
  //is user agrees a second time
  if (Application->MessageBox("This will overwrite the files you have selected with the ones in your backup.  Proceed?", "Restore?", MB_YESNO) == IDYES)
   //restore them
   restoreFile();
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
 if (Key == 'Z')
        isSpacePressed = true; 
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::FormKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
 isSpacePressed = false;
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::FormClose(TObject *Sender, TCloseAction &Action)
{
 for (unsigned i = 0; i < 6; i++)
        delete images[i];
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnHelpClick(TObject *Sender)
{
 AnsiString helpLoc = ExtractFilePath(ParamStr(0));
 ShellExecute(frmMain->Handle, "open", (helpLoc + "help.chm").c_str(), "", helpLoc.c_str(), SW_SHOW);
}
//---------------------------------------------------------------------------



